
; ========================================================
;			
;    -- BSTVariables.asm --
;			Jay Sullivan
; ========================================================
  

.386
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE
 			
;------------------------------------------------
;               Header
;------------------------------------------------

	;----------------------------
	;     Includes
	;----------------------------
		
		include BSTVariables.inc
		
	;----------------------------
	;     Prototypes
	;----------------------------
		
		WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
		SetItemFromList PROTO pItem:DWORD
		GetItemFromList PROTO pItem:DWORD
		DeleteItemFromList PROTO pItem:DWORD
		DWItoDWA PROTO  DWI:DWORD
;------------------------------------------------
;                .CODE
;------------------------------------------------

.CODE

	Start:
		invoke GetModuleHandle, NULL
		mov hInstance,eax
		invoke GetProcessHeap
		mov hHeap,eax
		invoke GetCommandLine
		mov CommandLine, eax
		invoke WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
		invoke ExitProcess,eax
		
		
;------------------------------------------------
;	WinMain
;------------------------------------------------
WinMain PROC hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG



	;------------------------------------------------
	;	Windows
	;------------------------------------------------
			
		;------------------------------------------------
		;	Main Window Register
		;------------------------------------------------
		
			mov wc.cbSize, Sizeof WNDCLASSEX
			mov wc.style, CS_HREDRAW or CS_VREDRAW
			mov wc.lpfnWndProc, Offset WndProc
			mov wc.cbClsExtra,NULL
			mov wc.cbWndExtra,NULL
			mov eax,hInst
			mov wc.hInstance,eax
			invoke CreateSolidBrush,0FFFFFFh
			mov wc.hbrBackground, eax
			mov wc.lpszMenuName, NULL
			mov wc.lpszClassName, Offset ClassName
			invoke LoadIcon, NULL, IDI_APPLICATION
			mov wc.hIcon,eax
			mov wc.hIconSm,0
			invoke LoadCursor, NULL, IDC_ARROW
			mov wc.hCursor,eax
			invoke RegisterClassEx, ADDR wc
			invoke LoadMenu, hInst, Offset MenuName
			mov hMenu,eax
		

		;------------------------------------------------
		;	Main Window Create
		;------------------------------------------------
		
				
			invoke CreateWindowEx, WS_EX_CLIENTEDGE, ADDR ClassName, ADDR szAppName,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,200,200,NULL,hMenu,hInst,NULL
			mov hwnd,eax
			

		;------------------------------------------------
		;	hEditKW Create
		;------------------------------------------------
		
			invoke CreateWindowEx, WS_EX_STATICEDGE, Offset szCEdit, $String("x"), WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT,30,15,120,25,hwnd,0,hInst,0
			mov hEditKW,eax
			
		;------------------------------------------------
		;	hEditDATA Create
		;------------------------------------------------
		
			invoke CreateWindowEx, WS_EX_STATICEDGE, Offset szCEdit, $String("25"), WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT,30,65,120,25,hwnd,0,hInst,0
			mov hEditDATA,eax

		;------------------------------------------------
		;	hButtonSet Create
		;------------------------------------------------
		
			invoke CreateWindowEx, WS_EX_STATICEDGE, Offset szCButton, $String("Set"), WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT,30,40,60,25,hwnd,0,hInst,0
			mov hButtonSet,eax
			
		;------------------------------------------------
		;	hButtonGet Create
		;------------------------------------------------
		
			invoke CreateWindowEx, WS_EX_STATICEDGE, Offset szCButton, $String("Get"), WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT,90,40,60,25,hwnd,0,hInst,0
			mov hButtonGet,eax
			
		;------------------------------------------------
		;	hButtonDump Create
		;------------------------------------------------
		
			invoke CreateWindowEx, WS_EX_STATICEDGE, Offset szCButton, $String("Dump All"), WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT,30,130,120,25,hwnd,0,hInst,0
			mov hButtonDump,eax
			
			

	;------------------------------------------------
	;	WinMain Code
	;------------------------------------------------
			
		;-----------------------------
		;	Show Window
		;-----------------------------
			
			invoke ShowWindow, hwnd, SW_SHOWNORMAL 
			invoke UpdateWindow, hwnd
			
		;-----------------------------
		;	Message Loop
		;-----------------------------
			
			jmp @F
			StartLoop:
			  invoke TranslateMessage,ADDR msg
			  invoke DispatchMessage, ADDR msg
			@@:
			  invoke GetMessage,ADDR msg,NULL,0,0
			  test eax, eax
			  jnz StartLoop
			
	mov eax, msg.wParam
	ret
WinMain ENDP


;------------------------------------------------
;	WndProc
;------------------------------------------------
WndProc PROC uses ebx hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
LOCAL myRect:RECT, 
	  ps:PAINTSTRUCT,
	  hdc:HDC,
	  hBrush:HBRUSH,
	  hPen:HPEN
	;-----------------------------
	 .if uMsg==WM_DESTROY
	;-----------------------------
		
		invoke PostQuitMessage, NULL
		
	;-----------------------------
	 .elseif uMsg==WM_CREATE
	;-----------------------------
			;-----------------------------
			; Create Font 14
			;-----------------------------
			
				    invoke GetDeviceCaps,hdc, LOGPIXELSY
				    invoke MulDiv,10, eax, 72
					neg eax
				    invoke CreateFont,eax, 0, 0, 0, 400, 0, 0, 0, 0, 0, 0, 0, 0, Offset myFontFace
					mov hf14, eax
					
					
	;-----------------------------
	 .elseif uMsg==WM_PAINT
	;-----------------------------
			
	invoke BeginPaint,hWnd,ADDR ps
	mov hdc, eax
		
		;-----------------------------
		; Create
		;-----------------------------
		invoke CreatePen,PS_DASH,4,0FF4411h
		mov hPen, eax
		invoke CreateSolidBrush,0FFFFh
		mov hBrush, eax
		;-----------------------------
		; Select
		;-----------------------------
		invoke SelectObject,hdc,hPen
		push eax
		invoke SelectObject,hdc,hBrush
		push eax
		
			invoke BeginPath,hdc
			invoke Rectangle,hdc,23,5,  156,100
			invoke Rectangle,hdc,23,105,156,160
			invoke EndPath,hdc
			invoke StrokeAndFillPath,hdc
			
			invoke SetBkMode, hdc,TRANSPARENT
			invoke TextOut,hdc,70,110,Offset TreeSizeA, 4
			
		;-----------------------------
		; Deselect
		;-----------------------------
		pop eax
		invoke SelectObject,hdc,eax
		pop eax
		invoke SelectObject,hdc,eax
		;-----------------------------
		; Delete
		;-----------------------------
		invoke DeleteObject,hBrush
		invoke DeleteObject,hPen
		
	invoke EndPaint,hWnd,ADDR ps
	;-----------------------------
	 .elseif uMsg==WM_COMMAND
	;-----------------------------
		
		mov eax,wParam
		;-----------------------------
		 .if ax== BN_CLICKED
		;-----------------------------
		
			mov eax, lParam
			.if eax==hButtonSet
				
			;-----------------------------
			; Make ITEM
			;-----------------------------
				invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY, Sizeof ITEM
				mov ebx, eax
					
				;-----------------------------
				; Name
				;-----------------------------
					invoke GetWindowTextLength,hEditKW
					add eax, 1
					mov [ebx].ITEM.dwNameLength, eax
					invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY,eax
					mov [ebx].ITEM.pName, eax
					invoke GetWindowText, hEditKW, eax, [ebx].ITEM.dwNameLength
				;-----------------------------
				; Data
				;-----------------------------
					invoke GetWindowTextLength,hEditDATA
					add eax, 1
					mov [ebx].ITEM.dwDataLength, eax
					invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY,eax
					mov [ebx].ITEM.pData, eax
					invoke GetWindowText, hEditDATA, eax, [ebx].ITEM.dwDataLength
				
				
				;-------------------------------------
				; Auto-set pItem into global LList
				;-------------------------------------
					invoke SetItemFromList, ebx
			
				;-------------------------------------
				; Update global count
				;-------------------------------------
					invoke DWItoDWA,TreeSize
					mov TreeSizeA, eax
					invoke InvalidateRect,hWnd,Offset myTextRect,TRUE
					
					
			.elseif eax==hButtonGet
			
			;-----------------------------
			; Make ITEM
			;-----------------------------
				invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY, Sizeof ITEM
				mov ebx, eax
				
				;-----------------------------
				; Name
				;-----------------------------
					invoke GetWindowTextLength,hEditKW
					add eax, 1
					mov [ebx].ITEM.dwNameLength, eax
					invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY,eax
					mov [ebx].ITEM.pName, eax
					invoke GetWindowText, hEditKW, eax, [ebx].ITEM.dwNameLength
					
				
				;-------------------------------------
				; Auto-get pItem from global LList
				;-------------------------------------
					
					invoke GetItemFromList, ebx
					.if eax!=0
						invoke SetWindowText, hEditDATA, [eax].ITEM.pData
					.endif
					
				;-------------------------------------
				; Update global count
				;-------------------------------------
					invoke DWItoDWA,TreeSize
					mov TreeSizeA, eax
					invoke InvalidateRect,hWnd,Offset myTextRect,TRUE
					
			.elseif eax==hButtonDump
			
				invoke DeleteItemFromList,ROOTITEM.ITEM.pRight
				mov ROOTITEM.ITEM.pRight, 0
				invoke DeleteItemFromList,ROOTITEM.ITEM.pLeft
				mov ROOTITEM.ITEM.pLeft, 0
				
					
			.endif
			
		;-----------------------------
		 .endif
		;-----------------------------
		
	;-----------------------------
	 .else
	;-----------------------------
		
		invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		ret
		
	;-----------------------------
	 .endif
	;-----------------------------
	
	xor eax,eax
	ret
WndProc ENDP

SetItemFromList PROC uses esi edi ebx pItem:DWORD

	;-----------------------------
	; cmps ROOTITEM, pItem
	;-----------------------------
	
		lea ebx, ROOTITEM
		mov edx, pItem
		
	;-----------------------------
	; Compare Strings 
	;-----------------------------
	CompareNextString:
	
		mov esi,    [ebx].ITEM.pName
		mov edi, 	[edx].ITEM.pName
		mov ecx,    [ebx].ITEM.dwNameLength
		mov eax, 	[edx].ITEM.dwNameLength
	
		cmp	 ecx, eax
		ja	 NoSwap
		xchg eax, ecx
NoSwap:	repe cmpsb
		jne  NotEqual
		mov  eax, [ebx].ITEM.dwNameLength
		cmp  eax, [edx].ITEM.dwNameLength
NotEqual:

	;-----------------------------
	; cmp edx,   ebx
	; cmp pItem, ?
	;-----------------------------
	;-----------------------------
	; Apply Results
	;-----------------------------
	jb LessThan
	ja GreaterThan
	
	;-----------------------------
	; String already exists
	;-----------------------------
	    push [edx].ITEM.pData
		invoke HeapFree, hHeap, HEAP_ZERO_MEMORY, [edx].ITEM.pName
		invoke HeapFree, hHeap, HEAP_ZERO_MEMORY, [ebx].ITEM.pData
		invoke HeapFree, hHeap, HEAP_ZERO_MEMORY, pItem
		pop [ebx].ITEM.pData
	jmp @F
	LessThan:
		.if [ebx].ITEM.pLeft!=0
			mov ebx, [ebx].ITEM.pLeft ; Branch left
			jmp CompareNextString
		.endif
		add TreeSize, 1
		mov [ebx].ITEM.pLeft, edx ; Attach left and end
	jmp @F
	GreaterThan:
		.if [ebx].ITEM.pRight!=0
			mov ebx, [ebx].ITEM.pRight ; Branch right
			jmp CompareNextString
		.endif
		add TreeSize, 1
		mov [ebx].ITEM.pRight, edx ; Attach right and end
	@@:
	
	ret
SetItemFromList ENDP

;You must make a heap ITEM zeroed, with pName set
; and get result in EAX
GetItemFromList PROC uses esi edi ebx pItem:DWORD

	;-----------------------------
	; cmps ROOTITEM, pItem
	;-----------------------------
	
		lea ebx, ROOTITEM
		mov edx, pItem
		
	;-----------------------------
	; Compare Strings 
	;-----------------------------
	CompareNextString:
	
		mov esi,    [ebx].ITEM.pName
		mov edi, 	[edx].ITEM.pName
		mov ecx,    [ebx].ITEM.dwNameLength
		mov eax, 	[edx].ITEM.dwNameLength
	
		cmp	 ecx, eax
		ja	 NoSwap
		xchg eax, ecx
NoSwap:	repe cmpsb
		jne  NotEqual
		mov  eax, [ebx].ITEM.dwNameLength
		cmp  eax, [edx].ITEM.dwNameLength
NotEqual:

	;-----------------------------
	; cmp edx,   ebx
	; cmp pItem, ?
	;-----------------------------
	jb LessThan
	ja GreaterThan
		
	;-----------------------------
	; String already exists
	;-----------------------------
		invoke HeapFree, hHeap, HEAP_ZERO_MEMORY, [edx].ITEM.pName
		invoke HeapFree, hHeap, HEAP_ZERO_MEMORY, pItem
		mov edx, ebx
	jmp @F
	LessThan:
		.if [ebx].ITEM.pLeft!=0
			mov ebx, [ebx].ITEM.pLeft ; Branch left
			jmp CompareNextString
		.endif
		add TreeSize, 1
		mov [ebx].ITEM.pLeft, edx ; Attach left and end
	jmp @F
	GreaterThan:
		.if [ebx].ITEM.pRight!=0
			mov ebx, [ebx].ITEM.pRight ; Branch right
			jmp CompareNextString
		.endif
		add TreeSize, 1
		mov [ebx].ITEM.pRight, edx ; Attach right and end
	@@:
	mov eax, edx
	ret
GetItemFromList ENDP

DeleteItemFromList PROC pItem:DWORD

	.if pItem!=0
	
		mov eax, pItem
		invoke DeleteItemFromList, [eax].ITEM.pRight
		
		mov eax, pItem
		invoke DeleteItemFromList, [eax].ITEM.pLeft
		
		mov eax, pItem
		.if [eax].ITEM.pData!=0
	 	 invoke HeapFree, hHeap, HEAP_ZERO_MEMORY, [eax].ITEM.pData
		.endif
		
		
	 	invoke HeapFree, hHeap, HEAP_ZERO_MEMORY, pItem

		;-------------------------------------
		; Update global count
		;-------------------------------------
			sub TreeSize, 1
			invoke DWItoDWA,TreeSize
			mov TreeSizeA, eax
			invoke InvalidateRect,hwnd,Offset myTextRect,TRUE
	.endif
	
	ret
DeleteItemFromList ENDP

;--------------------------------------------------
; Converts a DWORD integer to 4 decimal characters
;--------------------------------------------------
DWItoDWA PROC  DWI:DWORD
LOCAL xresult:DWORD
	mov xresult, 0
	mov eax, DWI
	mov ecx, 10
	
	xor edx, edx
	div ecx
	mov byte ptr xresult+3, dl
	
	xor edx, edx
	div ecx
	mov byte ptr xresult+2, dl
	
	xor edx, edx
	div ecx
	mov byte ptr xresult+1, dl
	
	xor edx, edx
	div ecx
	mov byte ptr xresult, dl
	
	mov eax, xresult
	add eax, 030303030h
	
	ret
DWItoDWA ENDP


End Start